/*
*  C Implementation: sh.c
*
* Description: Include all functions in screen handler
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/

#include      "shvar.c"                                    /* screen handler variables */
#include      "shmain.c"                                   /* function mainline */
#include      "shinit.c"                                   /* function mainline */

#include      "sh101.c"                                    /* read function */
#include      "sh102.c"                                    /* write function */
#include      "sh103.c"                                    /* Set unprotected attrib */
#include      "sh104.c"                                    /* Reset attribs to original */
#include      "sh105.c"                                    /* Save attibs */
#include      "sh106.c"                                    /* Restore attribs */
#include      "sh107.c"                                    /* Write message line */
#include      "sh108.c"                                    /* Write raw message line */
#include      "sh109.c"                                    /* Write raw message to log file */
#include      "sh110.c"                                    /* Write messages in new window */
#include      "sh111.c"                                    /* RW Redraw screen */
#include      "sh112.c"                                    /* Get/set font settings */
#include      "sh113.c"                                    /* Login */
#include      "sh120.c"                                    /* Fast-cgi Read function */
#include      "sh121.c"                                    /* Process response from fcgi_accept */
#include      "sh130.c"                                    /* Curses Read function */

#include      "sh202.c"                                    /* Move data to user */
#include      "sh203.c"                                    /* Does screen exist in TEMP table */
#include      "sh204.c"                                    /* Make new window */
#include      "sh205.c"                                    /* Make box around window */
#include      "sh206.c"                                    /* enqueue user's device */
#include      "sh208.c"                                    /* dequeue user's device */
#include      "sh209.c"                                    /* Find list data file */
#include      "sh210.c"                                    /* Move time and date to user area */
#include      "sh211.c"                                    /* Move time and date to user area */
#include      "sh212.c"                                    /* Update cursor from user data */

#include      "sh300.c"                                    /* Check for fcgi */
#include      "sh301.c"                                    /* Web handshake */
#include      "sh302.c"                                    /* Tell webui to Look for forked process */
#include      "sh303.c"                                    /* Connect screen */

#include      "sh502.c"                                    /* Message line */
#include      "sh503.c"                                    /* Reinit screen structs */
#include      "sh504.c"                                    /* Create core for window struct */
#include      "sh505.c"                                    /* Free code in a window struct */

#include      "sh600.c"                                    /* Process unprotected attrib */
#include      "sh602.c"                                    /* Output data to screen */
#include      "sh603.c"                                    /* Set Background color */
#include      "sh609.c"                                    /* Move curser position */
#include      "sh610.c"                                    /* Output Form to screen */
#include      "sh611.c"                                    /* Set colors and attribs for protected */

#include      "sh999.c"                                    /* Handle errors */
#include      "sh998.c"                                    /* Handle errors */
#include      "sh_curses.c"                                /* Ncurses replacement functions */
#include      "sh_html.c"                                  /* Html functions */
#include      "sh_debug.c"                                  /* Debug routines */
