/*
*  C Implementation: sh101
*
* Description: Read Screen
*
*
* Author: Kevin Lloyd <kalloyd@gmail.com>, (C) 2005
*
* Copyright: See COPYING file that comes with this distribution
*
*/

void
sh101 (char mode)
{

  eng_debug ("sh101: Read screen");

  if (Sh_flags.screen_mode == SH_WEB)
    {
      if (sh120 (mode) < 0)
        return;
    }
  else
    {
      if (sh130 (Sh_scr_ptr->current_win, mode) < 0)
        return;
    }

  sh202 ();                                                         /* Move data to user */
  memcpy (Sh_sh->data + ENG_SH_L1IKEY, Sh_key_pressed.ci, 2);       /* key goes on top line */
  memcpy (Sh_sh->data + ENG_SH_L1TIME, time_info (), 16);           /* move to user area */
  Sh_sh->status.ui = ENG_SH_OK;
  return;
}
