/*
*  C Implementation: sh103
*
* Description: Set unprotected attribute
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/
void sh103 ()
{
  int                     i;
  int                     row,col;
  unsigned char           attrib;
  FIELD                   *field;

  eng_debug ("sh103: Set unprotected attribute");

  /* The format of user data passed is yyxx(attrib) */
  row = atoi (make_string(Sh_sh->data,2,0,0,0,0));
  col = atoi (make_string(Sh_sh->data+2,2,0,0,0,0));
  attrib = *(Sh_sh->data+3);

  for (i = 0; i < Sh_scr_ptr->num_field; i++)
  {
    field = Sh_scr_ptr->field[i];
    if (row == (field->frow + Sh_scr_ptr->line_adj) && col == field->fcol)
    {
      /* set field to new attrib */
      sh600 (field, attrib);

      /* Create new unprotected screen */
      if (Sh_flags.screen_mode == SH_WEB)
        eng_post_form (Sh_scr_ptr->form);

      /* Refresh the screen */
      eng_wrefresh (Sh_scr_ptr->current_win);
      break;
    }
  }
}



