/*
*  C Implementation: sh110
*
* Description: Write message in a window
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/
void sh110 ()
{

  if (Sh_flags.detached == ON)                  /* if detatched */
    return;
  
  if (Sh_flags.screen_mode == SH_WEB)
  {
    FCGX_PutS ((char *) Sh_html_header.data, Sh_fcgi_io.out);
    memcpy (Sh_fcgi_header.screen_name, Sh_sh->data + ENG_SH_L1MAPN, 8);

    /* alert screen */
    Sh_fcgi_header.display_type = '3';
    FCGX_FPrintF (Sh_fcgi_io.out, "<!--#!HEADER!#%-*.*s#!HEADER!#-->\n", sizeof (Sh_fcgi_header), sizeof (Sh_fcgi_header), (char *) &Sh_fcgi_header);
    FCGX_PutStr (Sh_sh->data, Sh_sh->length, Sh_fcgi_io.out);
    FCGX_Accept_r (&Sh_fcgi_io);
    dump_fcgi ();
  }
  else
  {

    /* Declare variables. */
    CDKSCREEN    *cdkscreen;
    CDKDIALOG     *question  = 0;
    char         *buttons[] = {"OK"};
    char         **mesg;
    char         *buffer;
    int           i,j,count,offset,len;
    int           y,x,wrap;

    /* Set up CDK. */
    cdkscreen = initCDKScreen (Sh_scr_ptr->current_win);

    /* See how wide the screen is and wrap at 50% */
    getmaxyx(Sh_scr_ptr->current_win, y, x);
    wrap = x / 2;

    /* See if there are any line-breaks or wraps */
    for (i=0,j=1,len=0; i < Sh_sh->length; i++,len++)
    {
      if (*(Sh_sh->data+i) == '\x0a')
      {
        j++;
        len = 0;
      } else if (len == wrap)
      {
        j++;
        len = 0;
      }
    }

    /* Make storage for the pointers */
    mesg = calloc (j, sizeof (char *));

    /* Now make the messages looking to see if any line breaks */
    for (i=0,count=0,offset=0,len=0; i <= Sh_sh->length; i++,len++)
    {
      if (i == Sh_sh->length)
      {
        /* We are at the end of the data */
        if (len)
          mesg[count++] = make_string_r (&buffer, Sh_sh->data + offset, len, 0,0,0,0);
        break;
      }

      /* If a line break make a new mesg line */
      if (*(Sh_sh->data+i) == '\x0a')
      {
        /* len does not include the 0a */
        mesg[count++] = make_string_r (&buffer, Sh_sh->data + offset, len, 0,0,0,0);

        /* Move pass the 0a */
        offset = i + 1;
        len = 0;
      }
      else if (len >= wrap)
      {
        /* Wrap large messages */
        /* Try to wrap them at a blank */
        if (len > (wrap + 10) || *(Sh_sh->data+i) == ' ')
        {
          /* len does not include the blank */
          mesg[count++] = make_string_r (&buffer, Sh_sh->data + offset, len, 0,0,0,0);

          /* Move passwd the blank */
          offset = i + 1;
          len = 0;
        }
      }
    }

    /* Create the dialog box. */
    question = newCDKDialog (cdkscreen,
                             CENTER,
                             CENTER,
                             mesg, count, buttons, 1,
                             sh603 (SH_FORE_BLACK, SH_BACK_WHITE, SH_UNPRO_TYPE),
                             TRUE,
                             TRUE,
                             FALSE);


    /* Is the label null? */
    if (question == 0)
    {
      /* Clean up the memory. */
      destroyCDKScreen (cdkscreen);
      for (i=0; i < count; i++)
        free(mesg[i]);
      free (mesg);
      return;
    }

    /* Turn the cursor off */
    curs_set (0);

    /* Activate the dialog box. */
    activateCDKDialog (question, 0);

    /* Cursor back on */
    curs_set (1);

    /* Clean up. */
    destroyCDKDialog (question);
    destroyCDKScreen (cdkscreen);
    for (i=0; i < count; i++)
      free(mesg[i]);
    free (mesg);
  }

}
