/*
*  C Implementation: sh112
*
* Description: Get/set font settings
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2007
*
* Copyright: See COPYING file that comes with this distribution
*
*/
void sh112 ()
{
  eng_debug ("sh112: Get/set font settings (%2.2s)", Sh_sh->function.ci);

  switch (Sh_sh->function.ui)                                  /* process according to func */
  {
    case ENG_SH_GF:
    {
      *Sh_sh->data = SH_HTML_FONT_NAME;
      wrdadj (Sh_sh->data);
      break;
    }
    case ENG_SH_GS:
    {
      *Sh_sh->data = SH_HTML_FONT_SIZE;
      wrdadj (Sh_sh->data);
      break;
    }
    case ENG_SH_GR:
    {
      *Sh_sh->data = SH_HTML_ROW_PIXEL;
      wrdadj (Sh_sh->data);
      break;
    }
    case ENG_SH_GC:
    {
      *Sh_sh->data = SH_HTML_COL_PIXEL;
      wrdadj (Sh_sh->data);
      break;
    }
    case ENG_SH_SF:
    {
      SH_HTML_FONT_NAME = *flip_word(Sh_sh->data);
      FCGX_FPrintF (Sh_fcgi_io.out, "%s!#CMD#!0601%2.2d", Sh_html_header.data, SH_HTML_FONT_NAME);
      FCGX_Accept_r (&Sh_fcgi_io);

      /* This forces a repaint of the screen */
      memset (Sh_prev_screen, ' ', 8);
      break;
    }
    case ENG_SH_SS:
    {
      SH_HTML_FONT_SIZE = *flip_word(Sh_sh->data);
      FCGX_FPrintF (Sh_fcgi_io.out, "%s!#CMD#!0602%2.2d", Sh_html_header.data, SH_HTML_FONT_SIZE);
      FCGX_Accept_r (&Sh_fcgi_io);

      /* This forces a repaint of the screen */
      memset (Sh_prev_screen, ' ', 8);
      break;
    }
    case ENG_SH_SR:
    {
      SH_HTML_ROW_PIXEL = *flip_word(Sh_sh->data);
      FCGX_FPrintF (Sh_fcgi_io.out, "%s!#CMD#!0603%2.2d", Sh_html_header.data, SH_HTML_ROW_PIXEL);
      FCGX_Accept_r (&Sh_fcgi_io);

      /* This forces a repaint of the screen */
      memset (Sh_prev_screen, ' ', 8);
      break;
    }
    case ENG_SH_SC:
    {
      SH_HTML_COL_PIXEL = *flip_word(Sh_sh->data);
      FCGX_FPrintF (Sh_fcgi_io.out, "%s!#CMD#!0604%2.2d", Sh_html_header.data, SH_HTML_COL_PIXEL);
      FCGX_Accept_r (&Sh_fcgi_io);

      /* This forces a repaint of the screen */
      memset (Sh_prev_screen, ' ', 8);
      break;
    }
  }
}

