/*
*  C Implementation: sh120
*
* Description: Process FastCGI keys
*
*
* Author: Kevin Lloyd <kalloyd@gmail.com>, (C) 2005
*
* Copyright: See COPYING file that comes with this distribution
*
*/

int
sh120 (char mode)
{
  int             len, new_len, got_command;
  char           *contentLength;
  char           *converted;

  eng_debug ("sh120: Process fcgi keys");

  if (Sh_wrote_html)
    {
      while (1)
        {
          eng_debug ("sh120: Top level accept");
          FCGX_FPrintF (Sh_fcgi_io.out, "%s!#CMD#!01%c", Sh_html_header.data, mode + 48);
          if (FCGX_Accept_r (&Sh_fcgi_io) < 0)
            return (eng_error_out (Eng_error_mesg[14], "sh120: FCGX_Accept_r", strerror (errno)));
          else
            {
              contentLength = FCGX_GetParam ("CONTENT_LENGTH", Sh_fcgi_io.envp);
              if (contentLength != NULL)
                {
                  len = strtol (contentLength, NULL, 10);
                  eng_debug ("sh120: Wanted %d bytes, received %d bytes", Sh_sh->length, len);

                  if ((len + 1) > Sh_scr_ptr->input_buffer_length)
                  {
                    Sh_scr_ptr->input_buffer_length += len;
                    Sh_scr_ptr->input_buffer = realloc (Sh_scr_ptr->input_buffer, Sh_scr_ptr->input_buffer_length);
                  }

                  FCGX_GetStr (Sh_scr_ptr->input_buffer, len, Sh_fcgi_io.in);
                  eng_debug ("sh120: Received data:");
                  eng_debug_low (Sh_scr_ptr->input_buffer, len);

                  converted = make_string (Sh_scr_ptr->input_buffer, len,0,0,4,&new_len);
                  memcpy (Sh_scr_ptr->input_buffer, converted, new_len);

                  eng_debug ("sh120: Converted data:");
                  eng_debug_low (Sh_scr_ptr->input_buffer, new_len);

                  if (memcmp (Sh_scr_ptr->input_buffer, "!#INIT#!", 8) == 0)
                  {
                    eng_debug ("sh120: Received !#INIT#!, refreshing");
                    while (sh301 () < 0)
                      sleep (1);
                    eng_wrefresh (Sh_scr_ptr->current_win);
                  } else if (memcmp (Sh_scr_ptr->input_buffer, "!#GET#!", 7) == 0)
                  {
                    eng_debug ("sh120: Received !#GET#!, back to top");
                  }
                  else
                  {
                    /* We got a webpage */
                    memcpy (Sh_key_pressed.ci, Sh_scr_ptr->input_buffer + (len - 2), 2);                /* Key is suppose to be here */
                    memcpy (Sh_scr_ptr->web_cursor, Sh_scr_ptr->input_buffer + (len - 10), 4);           /* Cursor is suppose to be here */
                    got_command = 0;
                    switch (Sh_key_pressed.ui)
                    {
                      case ENG_SH_CM:
                      {
                        sh107 (0);
                        got_command = 1;
                        break;
                      }
                      case ENG_SH_KL:
                      {
                        sh999(ENG_SH_EN);
                        return (-1);
                      }
                      case ENG_SH_RW:
                      {
                        eng_wrefresh (Sh_scr_ptr->current_win);
                        got_command = 1;
                        break;
                      }
                    }
                    if (!got_command)
                      break;    /* get out okay */
                  }
                }
              else
                {
                  eng_debug ("sh120: Received 0 content length, refreshing"); 
                  eng_wrefresh (Sh_scr_ptr->current_win); 
                }
            }
        }
    }

    return (0);
}

