/*
*  C Implementation: sh121
*
* Description: Process response from fcgi_accept
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2007
*
* Copyright: See COPYING file that comes with this distribution
*
*/
int sh121 ()
{
  char           *contentLength;
  int             len;

  contentLength = FCGX_GetParam ("CONTENT_LENGTH", Sh_fcgi_io.envp);
  if (contentLength != NULL)
  {
    len = strtol (contentLength, NULL, 10);
    eng_debug ("sh121: Received %d bytes", len);

    if ((len + 1) > Sh_scr_ptr->input_buffer_length)
    {
      Sh_scr_ptr->input_buffer_length += len;
      Sh_scr_ptr->input_buffer = realloc (Sh_scr_ptr->input_buffer, Sh_scr_ptr->input_buffer_length);
    }

    FCGX_GetStr (Sh_scr_ptr->input_buffer, len, Sh_fcgi_io.in);
    eng_debug ("sh121: Received data:");
    eng_debug_low (Sh_scr_ptr->input_buffer, len);

    if (memcmp (Sh_scr_ptr->input_buffer, "!#INIT#!", 8) == 0)
    {
      eng_debug ("sh121: Received !#INIT#!");
      while (sh301 () < 0)
        sleep (1);
      return (len);
    } else if (memcmp (Sh_scr_ptr->input_buffer, "!#GET#!", 7) == 0)
    {
      eng_debug ("sh121: Received !#GET#!");
      return (len);
    }
    else
    {
      /* We got a webpage out of order */
      eng_debug ("sh121: Received web page out of sync");
      return (-1);
    }
  }
  else
  {
    eng_debug ("sh121: Received 0 content length");
    return (-1);
  }
}
