/*
*  C Implementation: sh202
*
* Description: Move data from screen to user
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/

int
sh202 ()
{
  int             datinx, web_index,wc_len;
  short int       i;
  int             dmax;
  char           *fld_buf,*buffer;
  FIELD          *field;

  eng_debug ("sh202: Move data from screen to user");

  web_index = 0;
  datinx = Sh_scr_ptr->beg_usr_data;
  if (datinx != 0)
    memcpy (Sh_sh->data, Sh_scr_ptr->line1_data, ENG_SH_L1LNTH);      /* Move saved line 1 data */

  if (Sh_scr_ptr->form)
    {
      if (Sh_flags.screen_mode == SH_TEXT)
        form_driver (Sh_scr_ptr->form, REQ_VALIDATION);
      
      for (i = 0; i < Sh_scr_ptr->num_field; i++)
        {
          if (datinx >= Sh_sh->length)
            break;

          field = Sh_scr_ptr->field[i];

          /* Don not allow bigger that allowed length */
          if ((datinx + field->maxgrow) > Sh_sh->length)
            dmax = Sh_sh->length - datinx;
          else
            dmax = field->maxgrow;

          if (Sh_flags.screen_mode == SH_TEXT)
            {
              if (field_status(field))
              {
                buffer = field_buffer (field, 0);
                memcpy (Sh_sh->data + datinx, make_string (buffer, eng_wcslen(buffer,dmax),0,0,2,0), dmax);
                set_field_status(field, 0);
              }
            }
          else
            {
              if (SH_ACTIVE (field))
                {
                  if (field_status(field))
                  {
                    buffer = Sh_scr_ptr->input_buffer + web_index;
                    wc_len = eng_wcslen(buffer,dmax);
                    fld_buf = make_string (buffer, wc_len,0,0,2,0);
                    web_index += wc_len;
                    
                    /* Give the field data */
                    if (set_field_buffer (field, 0, fld_buf) != E_OK)
                      return (sh998("sh202: set_field_buffer",ENG_SH_NC));

                    /* Give user the data */
                    memcpy (Sh_sh->data + datinx, fld_buf, dmax);
                    set_field_status(field, 0);
                  }
                  else
                    web_index += eng_wcslen(Sh_scr_ptr->input_buffer + web_index,dmax);
                }
              else
                {
                  if (field_status(field))
                  {
                    buffer = field_buffer (field, 0);
                    memcpy (Sh_sh->data + datinx, make_string (buffer, eng_wcslen(buffer,dmax),0,0,2,0), dmax);
                    set_field_status(field, 0);
                  }
                }
            }
          datinx += dmax;
        }

        if (Sh_flags.screen_mode == SH_TEXT)
        {
          Sh_sh->row = Sh_scr_ptr->form->currow;
          Sh_sh->col = Sh_scr_ptr->form->curcol;
        }
        else
        {
          Sh_sh->row = atoi (make_string (Sh_scr_ptr->web_cursor,2,0,0,0,0));
          Sh_sh->col = atoi (make_string (Sh_scr_ptr->web_cursor + 2,2,0,0,0,0));
        }
        Sh_sh->row++;
    }
  return (0);
}
