/*
*  C Implementation: sh205
*
* Description: Draw a box around window
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/
void
sh205 (WINDOW *win)
{
  char  *vl,*hl,*ul,*ur,*ll,*lr;
  int   endx,endy,i;

  if (Sh_scr_ptr->temp_header.hdbord != ' ' && Sh_flags.screen_mode == SH_TEXT)
    {
      if (Sh_scr_ptr->temp_header.hdbord == '1')
        {
          vl = Eng_utf8_char[SINGLE_VERTICAL];
          hl = Eng_utf8_char[SINGLE_HORIZONTAL];
          ul = Eng_utf8_char[SINGLE_UPPER_LEFT];
          ur = Eng_utf8_char[SINGLE_UPPER_RIGHT];
          ll = Eng_utf8_char[SINGLE_LOWER_LEFT];
          lr = Eng_utf8_char[SINGLE_LOWER_RIGHT];
        }
      else
        {
          vl = Eng_utf8_char[DOUBLE_VERTICAL];
          hl = Eng_utf8_char[DOUBLE_HORIZONTAL];
          ul = Eng_utf8_char[DOUBLE_UPPER_LEFT];
          ur = Eng_utf8_char[DOUBLE_UPPER_RIGHT];
          ll = Eng_utf8_char[DOUBLE_LOWER_LEFT];
          lr = Eng_utf8_char[DOUBLE_LOWER_RIGHT];
        }

      endx = win->_maxx;
      endy = win->_maxy;

      for (i = 1; i < endx; i++)
        {
          mvwaddstr (win, 0, i, hl);
          mvwaddstr (win, endy, i, hl);
        }

      for (i = 1; i < endy; i++)
        {
          mvwaddstr (win, i, 0, vl);
          mvwaddstr (win, i, endx, vl);
        }
      mvwaddstr (win, 0, 0, ul);
      mvwaddstr (win, 0, endx, ur);
      mvwaddstr (win, endy, 0, ll);
      mvwaddstr (win, endy, endx, lr);
    }
}

