/*
*  C Implementation: sh206
*
* Description: Put file lock on terminal device
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/

void
sh206 ()
{
  eng_debug ("sh206: Enqueue User's Terminal");

  /* 
     Since all locks are placed from a given position, we must seek to the same spot so it can be released. */
  if (Sh_flags.screen_mode == SH_TEXT)
    {
      lseek (1, 0L, 0);                                    /* seek to standard position */
      while (lockf (1, F_TLOCK, 0L))
        sleep (1);
      fcntl (1, F_SETFL, fcntl (1, F_GETFL) & ~O_NONBLOCK);
    }
  return;
}
