/*
*  C Implementation: sh208
*
* Description: Device file lock on terminal device
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/

int
sh208 ()
{
  /* 
     Since all locks are from a given position, we must re-seek to where lock was placed inorder to remove it. */

  eng_debug ("sh208: Dequeue User's Terminal");

  if (Sh_flags.screen_mode == SH_TEXT)
    {
      lseek (1, 0L, 0);                                /* seek to standard position */
      return (lockf (1, F_ULOCK, 0L));                 /* unlock and return */
    }
  return (0);
}
