/*
*  C Implementation: sh212
*
* Description: Get cursor position from user data
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/
void sh212 ()
{
  eng_debug ("sh212 - Get user cursor: row: %2.2s col: %2.2s linadj: %d", Sh_sh->data + ENG_SH_L1CURS, Sh_sh->data + ENG_SH_L1CURS + 2, Sh_scr_ptr->line_adj);

  if (*(Sh_sh->data + ENG_SH_L1CURS) == 'X')
  {
    Sh_scr_ptr->cur_col = cnvbin (Sh_sh->data + ENG_SH_L1CURS + 1, 3);
    Sh_scr_ptr->cur_row = -1;
  }
  else
  {
    /* Get current curser position */
    Sh_scr_ptr->cur_row = cnvbin (Sh_sh->data + ENG_SH_L1CURS, 2) - 1;
    Sh_scr_ptr->cur_col = cnvbin (Sh_sh->data + ENG_SH_L1CURS + 2, 2) - 1;

    /* If we are hiding the top line */
    if (Sh_scr_ptr->line_adj)
    {
      /* And the cursor was going to be on the top line the best
         we can do is set it to the first unprotected field */
      if (Sh_scr_ptr->cur_row == 0)
      {
        Sh_scr_ptr->cur_col = 1;
        Sh_scr_ptr->cur_row = -1;
      }
      else
        Sh_scr_ptr->cur_row -= Sh_scr_ptr->line_adj;
    }
  }
}

