/*
*  C Implementation: sh301
*
* Description:  Web handshake
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/
int
sh301 ()
{
  char    *contentLength;
  char    *input_buffer;
  int      len;
  char    *disp;      /* strtok dispisition */
  char    *token;     /* Pointer to next token */
  int      number_of_parms = 0;
  char    *font_name = "FONT_NAME=",*font_size = "FONT_SIZE=";
  char    *row_pixel = "ROW_PIXEL=",*col_pixel = "COL_PIXEL=";
  char    *browser_type = "BROWSER_TYPE=", *browser_os = "BROWSER_OS=";

  FCGX_FPrintF (Sh_fcgi_io.out, "%s!#CMD#!04", Sh_html_header.data);

  /* Send over the keymappings */
  FCGX_PutS ("!KEYS! ", Sh_fcgi_io.out);
  Sh_config_keys = Sh_beg_config_keys;
  while (Sh_config_keys)
  {
    FCGX_FPrintF (Sh_fcgi_io.out, "%s %s ", Sh_config_keys->config_keys->key, Sh_config_keys->config_keys->new_key);
    Sh_config_keys = Sh_config_keys->next_eng_config_keys_list;
  }

  /* Test sending over other things */
  FCGX_FPrintF (Sh_fcgi_io.out, ":first_key_blank=%c", eng_int_to_alnum (Sh_flags.first_key_blank));
  FCGX_Accept_r (&Sh_fcgi_io); 

  contentLength = FCGX_GetParam ("CONTENT_LENGTH", Sh_fcgi_io.envp);
  if (contentLength != NULL)
    {
      len = strtol (contentLength, NULL, 10);
      input_buffer = (char *) malloc (len + 1);
      FCGX_GetStr (input_buffer, len, Sh_fcgi_io.in);
      input_buffer[len] = '\0';
      if (memcmp (input_buffer, "!#INFO#!", 8) == 0)
        {
          if ((token = strtok_r (input_buffer, ":", &disp)) != NULL)      /* intial separation */
            {
              do
                {
                  eng_debug ("sh301: token: %s",token);
                  if (memcmp(token, font_name, strlen(font_name)) == 0)
                  {
                    SH_HTML_FONT_NAME = atoi (token+strlen(font_name));
                    number_of_parms++;
                  } else if (memcmp(token, font_size, strlen(font_size)) == 0)
                  {
                    SH_HTML_FONT_SIZE = atoi (token+strlen(font_size));
                    number_of_parms++;
                  } else if (memcmp(token, row_pixel, strlen(row_pixel)) == 0)
                  {
                    SH_HTML_ROW_PIXEL = atoi (token+strlen(row_pixel));
                    number_of_parms++;
                  } else if (memcmp(token, col_pixel, strlen(col_pixel)) == 0)
                  {
                    SH_HTML_COL_PIXEL = atoi (token+strlen(col_pixel));
                    number_of_parms++;
                  } else if (memcmp(token, browser_type, strlen(browser_type)) == 0)
                  {
                    *(token+12) = '\0';
                    setenv (token, token+13, 1);
                    *(token+12) = '=';
                    number_of_parms++;
                  } else if (memcmp(token, browser_os, strlen(browser_os)) == 0)
                  {
                    *(token+10) = '\0';
                    setenv (token, token+11, 1);
                    *(token+10) = '=';
                    number_of_parms++;
                  }
                }
              while((token = strtok_r(NULL, ":", &disp)) != NULL);
            }

            if (number_of_parms != 6)
            {
              free (input_buffer);
              return (eng_error_out("sh301: Error in web handshake: Invalid number of params (%s)", input_buffer));
            }
        }
      else
      {
        free (input_buffer);
        return (eng_error_out("sh301: Error in web handshake: %s", input_buffer));
      }
      free (input_buffer);
    }
  else
    return (eng_error_out("sh301: Error in web handshake: empty"));

  return (0);
}
