/*
*  C Implementation: sh502
*
* Description: Update the message lines
*
* Notes: Do not issue any error messages in here! As this is
*        the error processor as well. If this function fails
*        tough.
*
* Author: Ricardo Catu <ricky@smartcsc.com>, (C) 2005
*
* Copyright: See COPYING file that comes with this distribution
*
*/

int
sh502 (char mode)
{
  int   row, colum;
  char  *string_buffer = 0;

  eng_debug ("sh502 - UPDATE MESSAGE LINES");

  /*
     If master is defined then we are a child, don't acutally display the messages that have been built,
     simply signal the parent to do this. If master not defined, we are the parent, go ahead and display
     the message lines.
  */

  if (Sh_flags.detached == ON)                  /* if detatched */
    {
      struct _mesg_buf
        {
          long     mtype;                       /* message type, must be > 0 */
          char     mtext[SH_TMESG_LEN];         /* message data */
        }
      mesg_buf;

      eng_debug ("sh502: Send messages detached pid: %d", Sh_mast_pid);
      memcpy (mesg_buf.mtext, Sh_mesg2, SH_TMESG_LEN);
      mesg_buf.mtype = 1;
      if (msgsnd (Sh_mesg_id, &mesg_buf, SH_TMESG_LEN, IPC_NOWAIT) >= 0)
        {
          kill (Sh_mast_pid, SIGUSR1);                      /* child, signal parent */
        }
    }
  else
    {
      eng_debug ("sh502: Send messages attached");

      if (Sh_flags.screen_mode == SH_WEB)
        {
          short   pair_back;

          /* If we were signaled then we have to do this little hack */
          if (mode == 1)
            FCGX_Accept_r (&Sh_fcgi_io);

          Sh_fcgi_header.display_type = '2';      /* mesg screen */
          eng_html_header ();                    /* Put Header out */

          /* Where the field goes */
          eng_style_position (0, 0, 0, 0);

          /* Color and attributes of the field */
          if ((pair_back = PAIR_NUMBER(getbkgd(Sh_scr_ptr->current_win))) > 16)
              pair_back = 1;
          eng_style_color (Sh_color_pair[pair_back].html_back, "Red");

          /* Actual data */
          bformata (Sh_html_buffer, "<body><span style=\"%s %s\">%s</span>\n", Sh_style_position->data, Sh_style_color->data, make_string_r (&string_buffer, Sh_mesg1, SH_TMESG_LEN, 1, 0, 3, 0));
          free (string_buffer);
          /* Where the field goes */
          eng_style_position (1, 0, 0, 0);

          bformata (Sh_html_buffer, "<span style=\"%s %s\">%s</span>\n</body>", Sh_style_position->data, Sh_style_color->data, make_string_r (&string_buffer, Sh_mesg2, SH_TMESG_LEN, 1, 0, 3, 0));
          free (string_buffer);

          eng_debug ("sh502: HTML: %s", Sh_html_buffer->data);
          FCGX_PutStr((char *) Sh_html_buffer->data, Sh_html_buffer->slen, Sh_fcgi_io.out);
          FCGX_Accept_r (&Sh_fcgi_io);
          dump_fcgi ();
          Sh_wrote_html = ON;
        }
      else
        {
          getmaxyx (Sh_mesg_win, row, colum);
          if (colum > SH_TMESG_LEN)
            colum = SH_TMESG_LEN;
          sh206 ();                                                   /* wait 'till terminal is ours */

          wbkgdset (Sh_mesg_win, ' ' | sh603 (Sh_def_protected, Sh_def_background, SH_PRO_TYPE));
          sh609 (Sh_mesg_win, 1, 0);                                  /* position at first msg line */
          sh602 (Sh_mesg_win, Sh_mesg1, colum, 0, 0, 0);              /* display message 1 */
          sh609 (Sh_mesg_win, 0, 0);                                  /* position at second msg line */
          sh602 (Sh_mesg_win, Sh_mesg2, colum, 0, 0, 0);              /* display message 2 */
          eng_wrefresh (Sh_mesg_win);                                 /* flush output to terminal */
          sh208 ();                                                   /* release device for others */
          eng_wrefresh (Sh_scr_ptr->current_win);                     /* Put control back to main window */
        }
    }
    eng_debug ("sh502: end");
    return (0);
}

