/*
*  C Implementation: sh503
*
* Description: Reinit screen structs
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2005
*
* Copyright: See COPYING file that comes with this distribution
*
*/

void
sh503 (int mode)
{
  int              i;
  char            *next;

  eng_debug ("sh503: Reinit screen: mode: %d", mode);

  if (mode == 0)
  {
    /* Reinit current window */
    if (Sh_scr_data[Sh_current_scr_core].cur_window > 0)
    {
      /* Delete all popup structs */
      for (i=Sh_scr_data[Sh_current_scr_core].cur_window; i > 0; i--, Sh_scr_data[Sh_current_scr_core].cur_window--)
      {
        /* This will free most of the core in a win struct */
        sh505 ((char *) Sh_scr_data[Sh_current_scr_core].window[i]);

        /* Free the rest of the core */
        while (Sh_scr_data[Sh_current_scr_core].window[i]->sav_pdat_beg)
        {
          next = (char *) Sh_scr_data[Sh_current_scr_core].window[i]->sav_pdat_beg->tmpnxt;
          free (Sh_scr_data[Sh_current_scr_core].window[i]->sav_pdat_beg);
          Sh_scr_data[Sh_current_scr_core].window[i]->sav_pdat_beg = (struct _savp *) next;
        }

        if (Sh_scr_data[Sh_current_scr_core].window[i]->input_buffer)
          free (Sh_scr_data[Sh_current_scr_core].window[i]->input_buffer);

        delwin (Sh_scr_data[Sh_current_scr_core].window[i]->current_win);
        free (Sh_scr_data[Sh_current_scr_core].window[i]);
      }

      /* Point to the root window */
      Sh_scr_ptr = Sh_scr_data[Sh_current_scr_core].window[0];
    }

    /* Free and reinit most of the window core */
    sh505 ((char *) Sh_scr_ptr);
  }
  else
  {
    /* Create a new popup window */
    if (++Sh_scr_data[Sh_current_scr_core].cur_window == SH_NUM_WINDOW)
    {
      /* If we are to deep delete the window 1 and shift */
      Sh_scr_data[Sh_current_scr_core].cur_window--;

      /* This will free most of the core in a win struct */
      sh505 ((char *) Sh_scr_data[Sh_current_scr_core].window[1]);

      /* Free the rest of the core */
      if (Sh_scr_data[Sh_current_scr_core].window[1]->sav_pdat_beg)
        free (Sh_scr_data[Sh_current_scr_core].window[1]->sav_pdat_beg);
      if (Sh_scr_data[Sh_current_scr_core].window[1]->input_buffer)
        free (Sh_scr_data[Sh_current_scr_core].window[1]->input_buffer);
      free (Sh_scr_data[Sh_current_scr_core].window[1]);

      /* Shift */
      Sh_scr_data[Sh_current_scr_core].window[1] = Sh_scr_data[Sh_current_scr_core].window[2];
      Sh_scr_data[Sh_current_scr_core].window[2] = Sh_scr_data[Sh_current_scr_core].window[3];
    }

    /* Create core for window struct */
    sh504 (Sh_current_scr_core, Sh_scr_data[Sh_current_scr_core].cur_window);
    Sh_scr_ptr = Sh_scr_data[Sh_current_scr_core].window[Sh_scr_data[Sh_current_scr_core].cur_window];
    Sh_scr_ptr->is_popup = 1;
  }

  btrunc (Sh_html_pro_buffer, 0);
  btrunc (Sh_focus_name, 0);
}
