/*
*  C Implementation: sh505
*
* Description: Free all core in a window struct
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2007
*
* Copyright: See COPYING file that comes with this distribution
*
*/
void sh505 (char *screen_pt)
{
  struct _sh_screen   *scr_ptr;
  int                  i;

  scr_ptr = (struct _sh_screen *) screen_pt;

  if (scr_ptr->form)
  {
    /* Delete the sub window */
    unpost_form (scr_ptr->form);
    delwin (form_sub(scr_ptr->form));
    free_form (scr_ptr->form);
    scr_ptr->form = NULL;
  }

  for (i = 0; i < scr_ptr->num_field; i++)
  {
    if (scr_ptr->field[i])
    {
      if (scr_ptr->field[i]->usrptr)
        free (scr_ptr->field[i]->usrptr);
      free_field (scr_ptr->field[i]);
      scr_ptr->field[i] = 0;
    }
  }
  scr_ptr->num_field = 0;

  memset (&scr_ptr->temp_header, ' ', sizeof (struct _tmhdr));
  scr_ptr->beg_usr_data = 0;                           /* Start at top */
  scr_ptr->focus_field = 0;
  scr_ptr->sav_pdat = scr_ptr->sav_pdat_beg;
  scr_ptr->num_field = 0;
  scr_ptr->cur_col = scr_ptr->cur_row = 0;
  scr_ptr->line_adj = 0;
  scr_ptr->is_popup = 0;
}

