/*
*  C Implementation: sh600
*
* Description: Process unprotected attibute
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2007
*
* Copyright: See COPYING file that comes with this distribution
*
*/
unsigned char sh600 (FIELD *field, unsigned char attrib)
{
  /* See if unprotected */
  if ((attrib >= COLOR_PRO_BEG && attrib <= COLOR_PRO_END) || (attrib == DEFAULT_PRO) || (attrib == NONDISP_PRO))
  {
    /* Protected field */
    field_opts_off (field, O_ACTIVE);

    /* Non-Display */
    if (attrib == NONDISP_PRO)
      field_opts_off (field, O_PUBLIC);

    if (set_field_fore (field, sh603 (attrib, Sh_def_background, SH_UNPRO_TYPE)) != E_OK)
      return (sh998("sh600: set_field_fore failed", ENG_SH_NC));

    if (set_field_back (field, sh603 (attrib, Sh_def_background, SH_UNPRO_TYPE)) != E_OK)
      return (sh998("sh600: set_field_back failed", ENG_SH_NC));
  }
  else
  {
    if (!((attrib >= COLOR_UPRO_BEG && attrib <= COLOR_UPRO_END) || (attrib == DEFAULT_UPRO) || (attrib == NONDISP_UPRO)))
    {
      /* Invalid default to unpro */
      attrib = DEFAULT_UPRO;
    }

    if (Sh_def_pad_char != ' ' && !Sh_flags.pad_reverse)
    {
      if (Sh_scr_ptr->cur_row == 0)
      {
        if (Sh_flags.pad_top_line)
        {
          set_field_pad (field, Sh_def_pad_char);
        }
      }
      else
      {
        set_field_pad (field, Sh_def_pad_char);
      }
    }

    /* Unprotected */
    field_opts_on (field, O_ACTIVE);

    if (attrib == NONDISP_UPRO)
      field_opts_off (field, O_PUBLIC);
    else
      field_opts_on (field, O_PUBLIC);

    if (Sh_flags.pad_reverse)
    {
      if (set_field_fore (field, sh603 (SH_FORE_BLACK, SH_BACK_WHITE, SH_UNPRO_TYPE)) != E_OK)
        return (sh998("sh600: set_field_fore failed", ENG_SH_NC));

      if (set_field_back (field, sh603 (SH_FORE_BLACK, SH_BACK_WHITE, SH_UNPRO_TYPE)) != E_OK)
        return (sh998("sh600: set_field_back failed", ENG_SH_NC));
    }
    else
    {
      if (set_field_fore (field, sh603 (attrib, Sh_def_background, SH_UNPRO_TYPE)) != E_OK)
        return (sh998("sh600: set_field_fore failed", ENG_SH_NC));

      if (set_field_back (field, sh603 (attrib, Sh_def_background, SH_UNPRO_TYPE)) != E_OK)
        return (sh998("sh600: set_field_back failed", ENG_SH_NC));
    }
  }

  /* return correct attrib */
  return (attrib);
}

