/*
*  C Implementation: sh610
*
* Description: Output form to screen
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2005
*
* Copyright: See COPYING file that comes with this distribution
*
*/
int
sh610 (WINDOW * win) 
{
  eng_debug ("sh610: Output screen");

  wbkgdset (win, ' ' | sh603 (Sh_def_protected, Sh_def_background, SH_PRO_TYPE));

  if (Sh_scr_ptr->num_field)
    {
      if ((Sh_scr_ptr->form = new_form (Sh_scr_ptr->field)) == NULL)           /* Build form */
        return (sh998("sh610: new_form", ENG_SH_NC));
      set_form_win (Sh_scr_ptr->form, win);                      /* Set as current form in win */
      set_form_sub (Sh_scr_ptr->form, derwin (win, 0, 0, 0, 0)); /* Setup a sub form */
      set_current_field (Sh_scr_ptr->form, Sh_scr_ptr->field[Sh_scr_ptr->focus_field]);  /* Focus on curser */
      eng_post_form (Sh_scr_ptr->form);                              /* Output form to screen */
    }

  /* Ouput protected data to screen now */
  Sh_scr_ptr->sav_pdat = Sh_scr_ptr->sav_pdat_beg;
  while (Sh_scr_ptr->sav_pdat->tmplen)
    {
      if (sh611 (win, Sh_scr_ptr->sav_pdat->tmpatr) < 0)                    /* Set colors */
           return (-1);
      sh609 (win, Sh_scr_ptr->sav_pdat->tmplin, Sh_scr_ptr->sav_pdat->tmpcol);    /* Move curser */
      sh602 (win, Sh_scr_ptr->sav_pdat->tmpdat, Sh_scr_ptr->sav_pdat->tmplen, Sh_scr_ptr->sav_pdat->tmpfnt, Sh_scr_ptr->sav_pdat->tmpsty, Sh_scr_ptr->sav_pdat->tmpfsz);    /* Write data to screen */

      if (Sh_scr_ptr->sav_pdat->tmpnxt)                   /* Next in struct chain */
        Sh_scr_ptr->sav_pdat = Sh_scr_ptr->sav_pdat->tmpnxt;
      else
        break;
    }
    
    sh205 (win);               /* See if it needs a box */
    
    return (0);
}

