/*
*  C Implementation: sh_html
*
* Description: Collection of html creating functions
*
*
* Author: Ricardo Cantu <ricky@smartcsc.com>, (C) 2006
*
* Copyright: See COPYING file that comes with this distribution
*
*/

void eng_style_dimensions (int height, int width)
{
  bassignformat (Sh_style_dimensions, "position: absolute; height: %dpx; width: %dpx; ", SH_HTML_ROW_PIXEL * height, (SH_HTML_COL_PIXEL * width));
  if (Sh_scr_ptr->temp_header.hdbord != ' ')
    {
      if (Sh_scr_ptr->temp_header.hdbord == '1')
        bformata (Sh_style_dimensions,"border: thin solid #0000FF;");
      else
        bformata (Sh_style_dimensions,"border: thick groove #0000FF;;");
    }
}

void eng_style_position (int row, int col, int row_scew, int col_scew)
{
  /* Where the field goes */
  bassignformat (Sh_style_position, "position: absolute; top: %dpx; left: %dpx;", (SH_HTML_ROW_PIXEL * row) + row_scew, (SH_HTML_COL_PIXEL * col) + col_scew);
}

void eng_style_color_win (WINDOW *win)
{
  attr_t  attrs;
  short   pair_fore, pair_back;

  wattr_get(win, &attrs, &pair_fore, 0);
  if (pair_fore > 16 || pair_fore < 1)
    pair_fore = 1;
  pair_back = PAIR_NUMBER(getbkgd(win));
  if (pair_back > 16 || pair_back < 1)
    pair_back = 1;

  eng_style_color (Sh_color_pair[pair_back].html_back, Sh_color_pair[pair_fore].html_fore);
}

void eng_style_color_form (FIELD *field)
{
  short   pair_fore, pair_back;

  pair_fore = PAIR_NUMBER(field_fore(field));
  if (pair_fore > 16 || pair_fore < 1)
    pair_fore = 1;
  pair_back = PAIR_NUMBER(field_back(field));
  if (pair_back > 16 || pair_back < 1)
    pair_back = 1;

  eng_style_color (Sh_color_pair[pair_back].html_back, Sh_color_pair[pair_fore].html_fore);
}

void eng_style_color (char *back, char *fore)
{
  bassignformat (Sh_style_color, "background: %s; color: %s;", back, fore);
}

void eng_style_button (int width)
{
  bassignformat (Sh_style_button, "border: 3px double #999999; border-top-color: #CCCCCC; border-left-color: #CCCCCC; padding: 0em; background-color: #9BC4E2; color: #333333; font-size: 75%; font-weight: bold; width: %dpx;", (SH_HTML_COL_PIXEL * width));
}

void eng_html_header ()
{
  memcpy (Sh_fcgi_header.screen_name, Sh_sh->screen, 8);

  bassign (Sh_html_buffer, &Sh_html_header);
  bformata (Sh_html_buffer, "<!--#!HEADER!#%-*.*s#!HEADER!#-->\n", sizeof (Sh_fcgi_header), sizeof (Sh_fcgi_header), (char *) &Sh_fcgi_header);
}

